//Spi test
#include <HDL51001_ccf.h>
#include <spi.h>
#include <wdt.h>
#include <uart.h>

//16 bit word (12 bits data + 4 control bits)

void main(){
    int v_int, get_var;
    UART_InitTypeDef UART_InitStructure;
    
    UART_InitStructure.BaudRate = 38400; //set baudrate
    UART_InitStructure.TypeParity = 0x00000000; //parity control type
    UART_InitStructure.Parity = 0x00000000; //enable parity control
    UART_InitStructure.FlowControl = 0x00000000; //enable cts/rts
    UART_InitStructure.Mode = 0x00000003; //rx enable - 1 bit, tx enable - 2 bit (rx + tx en)  
        
    uart_init(UART3, &UART_InitStructure);
    
    WDT_OFF;
    
    GPIOD->BPS = 0xF7F; //uart + spi2 alternative port
    SPI_SSEN(SPI2, 1); //  S  SPI2
    SPI2->SS = 0x07; //  CS-ADC   
    SPI2->CR = 0x27F00000; // SPI2
    get_var = 0;
    
    while(1){
        //*((int*)(512)) = value; //    
        //DM2UART(UART3, (int)&value, 4); //  UART3   value  
        v_int = 0;
        while(SPI_ST_NF(SPI2) == 0); //   
        SPI2->SS = 0x06; //  CS-ADC   
        SPI2->TX = ((v_int & 0xFFF) | 0xC000)<<16; //     SPI2 (MSB,  )
        while(SPI_ST_TIP(SPI2) == 1); //   
        while(SPI_ST_NE(SPI2) == 0); //     
        SPI2->SS = 0x07; //  CS-ADC   
        get_var = SPI2->RX; //   ADC, c IN1
        uart_send_int(get_var, UART3);//    UART3
        while(UART_FIFO_TX_EMPTY(UART3) == 0); //    
    }
 
    // GPIOD->DIR = ((uint32_t)0x00007000);
    // GPIOD->OUT = ((uint32_t)0x00007000);
}















