; Define name of registers
.include "HDL50001_pcf.inc"
.alias Inv_byte 2

.text

start:
	jmp initUART0
	getl 0x00000300
	wrl @1, GPIOB_BPS
	getl 0x00000104
	wrl @1, UART0_BDR
complete

;;;;; Configurate Uart ;;;;;
initUART0:
	jmp MainLoop
	getl 0x0000000A
	wrl @1, UART0_DATA
	getl 0x00000003
	wrl @1, UART0_CR
complete

;RXD handler
Rxd_int:
    jmp buf_TXD
	rdl UART0_DATA
	not @1
	setl #Inv_byte, @1
complete

;test FIFO on full
buf_TXD:
	rdl UART0_ST
	getl 0x00000200
	and @1, @2
	jne @1, buf_TXD
	je @2, Send_byte
complete

;Send inverse byte
Send_byte:
	jmp MainLoop
	getl #Inv_byte
	wrl @1, UART0_DATA
complete

;;Loop
MainLoop:
	rdl UART0_ST
	getl 0x00000001
	and @2,@1
	je @1, MainLoop
	jne @2, Rxd_int 
complete

