//Uart test
#include <HDL51001_ccf.h>
#include <i2c.h>
#include <uart.h>


void pause(unsigned int a)
{
  unsigned int i;
  for(i=a;i>0;i--);
}

void main()
{
	int slv_addr;
	char byte_user;
	char byte;
	UART_InitTypeDef UART_InitStructure;
	
	
  
	  UART_InitStructure.BaudRate = 38400; //set baudrate
      UART_InitStructure.TypeParity = 0x00000000; //parity control type
      UART_InitStructure.Parity = 0x00000000; //enable parity control
      UART_InitStructure.FlowControl = 0x00000000; //enable cts/rts
      UART_InitStructure.Mode = 0x00000003; //rx enable - 1 bit, tx enable - 2 bit (rx + tx en)
	  
		GPIOB->BPS = 0x00000300; //alternative port function for uart0
		uart_init(UART0, &UART_InitStructure);
		//DM2UART(UART0, 0x00000000, 0x00000800);
		//pause(10000);
		UART_SEND_BYTE(0xAB, UART0);
		
	slv_addr = 0xA0; //address for read
	GPIOA->BPS = 0x00C00000; //alternative port function for i2c0(master)
	while(UART_NEW_DATA(UART0) == 0); //waiting byte from uart0
	byte_user = UART_GET_BYTE(UART0); //receive byte from user on uart0
	
	i2c0_init(1, 100000);
	
	i2c0_send(byte_user, slv_addr, 0);
	/*
	//write
	I2C0_TX_DATA(slv_addr); //set Slave Address for transmit
	I2C0_CMD(I2C0_START_WR); //send START + WR
	while(I2C0_TIP == 1); //wait end of data transmit
	while(I2C0_ACK_RX == 1); //wait ACK
	
	I2C0_TX_DATA(0x00); //set first address byte for transmit
	I2C0_CMD(I2C0_WR); //send WR
	while(I2C0_TIP == 1); //wait end of data transmit
	while(I2C0_ACK_RX == 1); //wait ACK
	
	I2C0_TX_DATA(0x00); //set second address byte for transmit
	I2C0_CMD(I2C0_WR); //send WR
	while(I2C0_TIP == 1); //wait end of data transmit
	while(I2C0_ACK_RX == 1); //wait ACK
	
	I2C0_TX_DATA(byte_user); //set byte for transmit
	I2C0_CMD(I2C0_WR); //send WR
	while(I2C0_TIP == 1); //wait end of data transmit
	while(I2C0_ACK_RX == 1); //wait ACK
	
	I2C0_CMD(I2C0_STOP_WR); //send STOP + WR
	while(I2C0_TIP == 1);
	while(I2C0_ACK_RX == 1);
	*/
	
	pause(10000);
	
	/*
	//read
	slv_addr = 0xA0; //address for write
	I2C0_TX_DATA(slv_addr); //set Slave Address for transmit
	I2C0_CMD(I2C0_START_WR); //send START + WR
	while(I2C0_TIP == 1); //wait end of data transmit
	while(I2C0_ACK_RX == 1); //wait ACK
	
	I2C0_TX_DATA(0x00); //set first address byte for transmit
	I2C0_CMD(I2C0_WR); //send WR
	while(I2C0_TIP == 1); //wait end of data transmit
	while(I2C0_ACK_RX == 1); //wait ACK
	
	I2C0_TX_DATA(0x00); //set second address byte for transmit
	I2C0_CMD(I2C0_WR); //send WR
	while(I2C0_TIP == 1); //wait end of data transmit
	while(I2C0_ACK_RX == 1); //wait ACK
	
	slv_addr = 0xA1; //address for read
	I2C0_TX_DATA(slv_addr); //set Slave Address for transmit
	I2C0_CMD(I2C0_START_WR); //send START + WR
	while(I2C0_TIP == 1); //wait end of data transmit
	while(I2C0_ACK_RX == 1); //wait ACK
	
	I2C0_CMD(I2C0_NACK_RD_STOP); //send NACK + RD + STOP
	while(I2C0_TIP == 1); //wait end of data transmit
	byte = I2C0_RX_DATA; //read received byte
	*/
	
	*((char*)(512)) = i2c0_get(slv_addr, 0); //write byte to DM
	
	DM2UART(UART0, 0x00000000, 0x00000800);
	
	GPIOB->DIR = ((uint32_t)0x60000000);
	GPIOB->OUT = ((uint32_t)0x60000000);
	
		
}













